var app = {

    showAlert: function (message, title) {
        if (navigator.notification) {
            navigator.notification.alert(message, null, title, 'OK');
        } else {
            alert(title ? (title + ": " + message) : message);
        }
    },

    registerEvents: function() {
        $(window).on('hashchange', $.proxy(this.route, this));
//        $('body').on('mousedown', 'a', function(event) {
        $('body').on('touchstart', 'a', function(event) {
            $(event.target).addClass('tappable-active');
        });
//        $('body').on('mouseup', 'a', function(event) {
        $('body').on('touchend', 'a', function(event) {
            $(event.target).removeClass('tappable-active');
        });
    },


    route: function() {
    var self = this;
    var hash = window.location.hash;
    //direction = window.location.hash.substr(1).split('&');
    direction ='';
    articletype ='';
    page = hash.substring(1,hash.indexOf("?"));
    var params = hash.substr(hash.indexOf("?")+1);

    params = params.split("&");
    for (var i=0; i<params.length; i++)
       {
       	
         temp = params[i].split("=");
         if ( [temp[0]] == 'articletype' ) { articletype = temp[1]; }
         if ( [temp[0]] == 'direction' ) { direction = temp[1]; }

       }

        	//console.log('mainjs type: '+articletype);
        	//console.log('mainjs direction: '+direction);
            //console.log('mainjs hash: '+hash);
            //console.log('mainjs page: '+page);
        	        	
   
  
      
   
   if (page == 'home'){
   		//console.log('this home');
   		this.homePage = new HomeView(this.store).render();
		this.slidePage(this.homePage,direction,page);
   }
   else if (page == 'menu'){
   		//console.log('this menu');
   		this.catPage = new MenuView(this.store).render();
   		this.slidePage(this.catPage,direction,page);     
   }
   else if (page == 'about'){
   		//console.log('this about');
   		this.catPage = new AboutView(this.store).render();
   		this.slidePage(this.catPage,direction,page);     
   }

  else if (page == 'anpnieuws'){
   		//console.log('this about');
   		this.catPage = new HomeView(this.store).render();
   		this.slidePage(this.catPage,direction,page);     
	   }
else if (page == 'anpeconomie'){
   		//console.log('this about');
   		this.catPage = new HomeView(this.store).render();
   		this.slidePage(this.catPage,direction,page);     
	   }
	   
  else if (page == 'anpsport'){
   		//console.log('this about');
   		this.catPage = new HomeView(this.store).render();
   		this.slidePage(this.catPage,direction,page);     
	   }
else if (page == 'anpberoemd'){
   		//console.log('this about');
   		this.catPage = new HomeView(this.store).render();
   		this.slidePage(this.catPage,direction,page);     
	   }

   else if  (!hash) {
      	//console.log('this homepage');
      	this.homePage = new HomeView(this.store).render();
		this.slidePage(this.homePage);
   }
   else 
   {      	//console.log('error geen keuze kunnen maken');
   	}

      
    var match = hash.match(this.detailsURL);
    if (match) {
    	           // console.log('mainjs match: '+match);

        	this.store.findById(Number(match[1]), articletype,function(article) {
            self.slidePage(new ArticleView(article).render(),direction);
            
// Using Hammer for swiping between pages
//var hammertime = $("#artikel").hammer( );

   var hammertime = Hammer($("#artikel"), {
        drag: false,
        transform: false
    });




//.on("release dragleft dragright swipeleft swiperight", handleHammer);
hammertime.on("swiperight", function(ev) {
	           // console.log(ev);

 // console.log('swiperight!');
  var button = document.getElementById("backbutton");          				   	
 // console.log('swipe mainjs rg 110 nu vervang href: '+button);
  if (button == null) {  window.location.href = $('#logoback').attr('href');}
  else {    
   	window.location.href = $('#backbutton').attr('href');}
});

hammertime.on("swipeleft", function(ev) {
	//console.log(ev);
  //console.log('swipeleft!');
  var button = document.getElementById("forwardbutton");          				   	
  //console.log('swipe mainjs rg 110 nu vervang href: '+button);
  if (button == null) {  window.location.href = $('#logoback').attr('href');}
  else {    window.location.href = $('#forwardbutton').attr('href');}  							
}); 
 
hammertime.on("dragleft", function(ev) {
	    //        console.log(ev);
  //console.log('dragleft!');
 });
hammertime.on("dragright", function(ev) {
	         //   console.log(ev);
  //console.log('dragright!');
 });

hammertime.on("release", function(ev) {
	           // console.log(ev);
  //console.log('release!');
              pane_width = $(window).width();
              halfscreen = pane_width/2;
         //     console.log(pane_width);
        //      console.log(pageXOffset);
                            

          // more then 50% moved, navigate
                    if(pageXOffset> 0) {
                    	if (pageXOffset< halfscreen){	
   $( 'html, body' ).animate({scrollLeft:0},'slow');
                          } 
                          else {
   $( 'html, body' ).animate({scrollLeft:pane_width},'slow');         	
                          	}
                          
                    }
                    
            
            
            
 });



             });
        }
    },
    
    slidePage: function(page,direction,pagetype) {
     	  console.log('page :'+page);

     var currentPageDest,
        self = this;
    // If there is no current page (app just started) -> No transition: Position new page in the view port
    if (!this.currentPage) {
        $(page.el).attr('class', 'page stage-center');
        $('body').append(page.el);
        this.currentPage = page;
        return;
    }
 
    // Cleaning up: remove old pages that were moved out of the viewport
    $('.stage-right, .stage-left').not('.homePage').remove();


	if (direction === 'forward') {
    	  //console.log('slidepage: forward');
    	    	        // Forward transition (slide from right)
         $(page.el).attr('class', 'page stage-right');
        currentPageDest = "stage-left";
    }  
    else if (direction === 'backward') {
    	    	console.log('slidepage: backward');
    	    	
    	    	
        // Forward transition (slide from left)
        $(page.el).attr('class', 'page stage-left');
        currentPageDest = "stage-right";
    }
    else if (page === app.homePage) {
    	//console.log('slidepage: homepage');
        $(page.el).attr('class', 'page stage-left');
        currentPageDest = "stage-right";
    }     
    else {
        // Forward transition (slide from right)
            	    	//console.log('slidepage: forward');

        $(page.el).attr('class', 'page stage-right');
        currentPageDest = "stage-left";
    }
     // Change ID's buttons old page for swiping between pages
		$(".stage-center #backbutton").attr('id', 'backbuttonold')
       $(".stage-center #forwardbutton").attr('id', 'forwardbuttonold')
    $(".stage-center #artikel").attr('id', 'artikelold')
	//console.log('artikel is old');
    $('body').append(page.el);

	 //console.log('mainjs body append');

	
    // Wait until the new page has been added to the DOM...
    setTimeout(function() {
        // Slide out the current page: If new page slides from the right -> slide current page to the left, and vice versa
        
  //         $(".stage-center .scroll").attr('class', 'scrollold')


        $(self.currentPage.el).attr('class', 'page transition ' + currentPageDest);
        // Slide in the new page
        $(page.el).attr('class', 'page stage-center transition ');
        self.currentPage = page;
        
                

	        		
    },0);
    
 
 
},

    initialize: function() {
        var self = this;
        this.detailsURL = /^#articles\/(\d{1,})/;
        this.registerEvents();
        this.store = new MemoryStore(function() {
            self.route();
        });
    }

};



function getURLParameter(name) {
  return decodeURIComponent((new RegExp('[?|&]' + name + '=' + '([^&;]+?)(&|#|;|$)').exec(location.search)||[,""])[1].replace(/\+/g, '%20'))||null
}

function loadingSpinner(method){

if (method == 'on') {
//get hoogste z-index 
var elements = document.getElementsByTagName("*");
var highest_index = 0;

for (var i = 0; i < elements.length - 1; i++) {
    if (parseInt(elements[i].style.zIndex) > highest_index) {
        highest_index = parseInt(elements[i].style.zIndex);
    }
}
//console.log ('loading spinner');
 
  //Adjust to screen size
  var pHeight = window.innerHeight;
  var pWidth =window.innerWidth;
  var sH = parseInt($('#loadingSpinner').css('height'));
  var sW = parseInt($('#loadingSpinner').css('width'));
  $('#loadingSpinner').css('top',(pHeight-sH)/2)
  $('#loadingSpinner').css('left',(pWidth-sW)/2)
  $('#loadingSpinner').css('z-index', highest_index + 1);
  //Show
  $('#loadingSpinner').show();
} else if (method == 'off'){
  $('#loadingSpinner').hide();
}
}


function toggle(id) {
    var el = document.getElementById(id);
    var menuright = document.getElementById('menuright');
    var mnu = document.getElementsByClassName('menuicon');
    var box = el.getAttribute("class");
    if(box == "hide"){
        el.setAttribute("class", "show");
        menuright.setAttribute("class", "showmenuright");
       // dissolver.setAttribute("class", "toon");
        n = mnu.length;
   for (var i = 0; i < n; i++) {
     var e = mnu[i];

      e.setAttribute("id", "menu-button-menu-klein");
   }
    }
    else{
        el.setAttribute("class", "hide");
                menuright.setAttribute("class", "hidemenuright");

        //dissolver.setAttribute("class", "verberg");

           n = mnu.length;
   for (var i = 0; i < n; i++) {
     var e = mnu[i];

      e.setAttribute("id", "menu-button-menu-groot");
   }

    }
}

        

  
function getArticle(id,type){
	  console.log('function getArticlebyID: '+ id);
       var articles = JSON.parse(window.localStorage.getItem("articleshome"));
       var article = null;
        var l = articleswel.length;
		var searchvar = id;
        for (var i=0; i < l; i++) {
        	            	                //console.log('memory store id check : '+ articleswel[i].id);

            if (articleswel[i].id == searchvar) {

                article = articleswel[i];

                article.soort ='home';
                if (i == 0){ article.backid = '';
                } else {     article.backid = articleswel[i-1].id;}
				if (i == l-1){ article.nextid = '';
	            } else {article.nextid = articleswel[i+1].id;}   
                break;
            }
        }
	
	}           



 function checkConnection() {
       var networkState = navigator.connection.type;
            if (networkState == Connection.NONE){
            showAlertNoConnection();
			};

        }

function showAlertNoConnection() {

	navigator.notification.confirm(
            'U heeft geen internet connectie.',  // message
            onConfirmQuit, //callback 
            'Helaas, er is iets mis:',            // title
            'Afsluiten, Verder zonder connectie'                  // buttonName
        );
}
function onConfirmQuit(button) {
	 if(button == "1"){
        navigator.app.exitApp(); 
    }
    if(button == "2"){
        navigator.app.initialize(); 
    }

}
 
function onMenuKeyDown() {
	console.log('onMenuKeyDown');
toggle('menubox');
}
  
    


 function onBackKeyDown() {
	console.log('onBackKeyDown');


  var button = document.getElementById("logoback");          				   	
  if (button) {  location = $('#logoback').attr('href');
  		} 	else{
  		location ="#home?direction=backward";
  		}



this.document.location.href = location;
	

    }

    function hideToast(){
    var alert = document.getElementById("toast");
    alert.style.opacity = 0;
     
    }
    
   function drawToast(message){
		
		var alert = document.getElementById("toast");
		
		if (alert == null){
			var toastHTML = '<div id="toast">' + message + '</div>';
			document.body.insertAdjacentHTML('beforeEnd', toastHTML);
		}
		else{
			alert.style.opacity = .9;
		}
		
		
		intervalCounter = setInterval("hideToast()", 1000);
	}
 


	// Wait for Phonegap to load
    //
    document.addEventListener("deviceready", onDeviceReady, false);
    function onDeviceReady() {
    	console.log('DeviceReady');
    	document.addEventListener("menubutton", onMenuKeyDown, false);
    	document.addEventListener("backbutton", onBackKeyDown, false);
    	checkConnection();
		FastClick.attach(document.body);
    	ImgCache.init();
   
        navigator.splashscreen.hide();
        var direction;
        var page;
       
    }

app.initialize();
